//*****************************************
// AT mega328P-PU(28pin 300mil SDIP) Four IN-18 Clock Program
// CPU Clock:8MHz
//   iq[Yf[^@WȂBIV[^(8MHz)ɂj
//
// File Name:display.c
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//*****************************************

#include	"four_in18_clock.h"
#include	"nixie.h"
#include	"display.h"

//  Qabc̕\
void	disp_nixie_tow_h(unsigned char bcd)
{
	disp_dynamic_nixie_number(0, bcd >> 4);		// 
	disp_dynamic_nixie_number(1, bcd & 0x0f);	// 
}
//  Qabc̕\
void	disp_nixie_tow_m(unsigned char bcd)
{
	disp_dynamic_nixie_number(2, bcd >> 4);		// 
	disp_dynamic_nixie_number(3, bcd & 0x0f);	// 
}
//  Qabc̕\
void	disp_nixie_tow_l(unsigned char bcd)
{
	disp_dynamic_nixie_number(4, bcd >> 4);		// 
	disp_dynamic_nixie_number(5, bcd & 0x0f);	// 
}
// Sabc̕\
void	disp_nixie_four(unsigned char bcd_h, unsigned char bcd_l)
{
	disp_dynamic_nixie_number(0, bcd_h >> 4);		// 
	disp_dynamic_nixie_number(1, bcd_h & 0x0f);		// 
	disp_dynamic_nixie_number(2, bcd_l >> 4);		// 
	disp_dynamic_nixie_number(3, bcd_l & 0x0f);		// 
}
// Uabc̕\
void	disp_nixie_six(unsigned char bcd_h, unsigned char bcd_m, unsigned char bcd_l)
{
	disp_dynamic_nixie_number(0, bcd_h >> 4);		// 
	disp_dynamic_nixie_number(1, bcd_h & 0x0f);		// 
	disp_dynamic_nixie_number(2, bcd_m >> 4);		// 
	disp_dynamic_nixie_number(3, bcd_m & 0x0f);		// 
	disp_dynamic_nixie_number(4, bcd_l >> 4);		// 
	disp_dynamic_nixie_number(5, bcd_l & 0x0f);		// 
}
// S\iXXXX܂Łj
void	disp_nixie_4binary(unsigned short us)
{
	if(9999 < us){
		us = 9999;
	}
	disp_dynamic_nixie_number(0, us/1000);			// 
	disp_dynamic_nixie_number(1, (us%1000)/100);	// 
	disp_dynamic_nixie_number(2, (us%100)/10);		// 
	disp_dynamic_nixie_number(3, us%10);			// 

}
