//*****************************************
// AT mega328P-PU(28pin 300mil SDIP) Four IN-18 Clock Program
// CPU Clock:8MHz
//   iq[Yf[^@WȂBIV[^(8MHz)ɂj
//
// File Name:eep_dat.c
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/eeprom.h>

#include	"four_in18_clock.h"
#include	"port_bit.h"
#include	"timer.h"
#include	"ad_conv.h"
#include	"nixie.h"
#include	"eep_dat.h"

unsigned char	eep_change_path EEMEM = 6;				// ۑ \Ԉؑ֒l 0--9 (0:bright -- 9:dark ̒lPOOؑ֒l)

static	unsigned char	eep_bf[10];

//*****************************************
//@ddoqnl change_PATH ǂݍ
//*****************************************
unsigned char	read_eep_change_path(void)
{
	unsigned char	r = 0;

	eeprom_busy_wait();
	eep_bf[0] = eeprom_read_byte(&eep_change_path);		// Ǐo
	if((0 <= eep_bf[0])&&(eep_bf[0] <= 9)){
		r = eep_bf[0];
	}else{
		r = 9;
	}

	return(r);
}

//*****************************************
//@ddoqnl change_PATH 
//*****************************************
static
void	write_eep_change_path(unsigned char uc)
{
	eep_bf[0] = uc;
	eeprom_busy_wait();
	eeprom_write_byte(&eep_change_path, eep_bf[0]);		// 
	eeprom_busy_wait();
}

//*****************************************
//@ddoqnlchange_PATHҏW
//*****************************************
static
void	edit_eep_change_path(void)
{
	unsigned short	us;
	unsigned char	pt;
	unsigned char	blk_stat = 0;
	unsigned char	blink_time = 30;					// uNԊu

	pt = change_path;
	disp_dynamic_nixie_number(0, 15);
	disp_dynamic_nixie_number(1, pt);
	disp_dynamic_nixie_number(2, 0);
	disp_dynamic_nixie_number(3, 0);

	tim_10ms_blink = 0;								// _
	while(1){
		us = get_action_sw();									// XCb`Ԃ
		us = us & SW_MASK;										// XCb`ɂ

		if(tim_10ms_blink == 0){								// _Ń^C~O̎
			tim_10ms_blink = blink_time;
			if((blk_stat==0)&&((us & SW2_ON) == 0)&&((us & SW1_ON) == 0)){			// ꂢȂ ł̎(select switch)
				blk_stat = 1;
				disp_dynamic_nixie_number(1, 15);
			}else{
				blk_stat = 0;
				disp_dynamic_nixie_number(1, pt);
			}
		}

		if(us != 0){											// EANVL鎞
			if(((us & SW2_ON_CONTINUE) != 0)||((us & SW2_ON_NOW) != 0)){	// ꑱAꂽ(select switch)

				if(9 <= pt){
					pt = 0;
				}else{
					pt++;
				}
				disp_dynamic_nixie_number(1, pt);				// l̂P\
				tim_10ms_blink = blink_time;					// uNԊu
			}else if(((us & SW1_OFF_LONG) != 0)||((us & SW1_OFF_SHORT) != 0)){	// ZAAꎞ(set switch)
				cli();
				change_path = pt;
				write_eep_change_path(change_path);				// ddoqnl change_PATH ɏ
				led_on();										// LED ON
				delay_ms(100);									// 100mS Delay
				led_off();										// LED OFF
				sei();											// 荞݉
			}
		}

	}

}

//*****************************************
//@ddoqnlDATAҏW
//  iv[v
//*****************************************
void	edit_eep_data(void)
{
	while(1){
		edit_eep_change_path();							// ddoqnlchange_PATHҏW
	}
}
