//*****************************************
// AT mega328P-PU(28pin 300mil SDIP) Four IN-18 Clock Program
// CPU Clock:8MHz
//   iq[Yf[^@WȂBIV[^(8MHz)ɂj
//
// File Name:four_in18_clock.c
//@ pro_in14_clock ̃vWFNgRs[ā@in18@ɂ킹B
//
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/io.h>

#include	"four_in18_clock.h"
#include	"timer.h"
#include	"port_bit.h"
#include	"display.h"
#include	"ad_conv.h"
#include	"nixie.h"
#include	"rtc_ds3234.h"
#include	"set_rtc.h"
#include	"eep_dat.h"
#include	"infrared.h"

unsigned char			g_keta;

static	unsigned char	run=0;
static	int				bef1_ad_ave=0;
static	unsigned char	num_count=0;
static	unsigned char	renzoku[16]={1,0,2,9,8,3,4,7,6,5,15,15,15,15,15,15};			// ̑w̑w
static	unsigned char	gyaku_renzoku[16]={5,6,7,4,3,8,9,2,0,1,15,15,15,15,15,15};		// ̑w牺̑w


//***************************
// `FbNiX^eBbN\js
//  kdcRx_łAR_
//  R_Ă鎞 XCb`閈ɂnm^neeJԂA
//  e̐\Ă鎞 XCb`閈ɂO`XԂɕ\
//  XCb` \錅ړB ԍ珇ԂŁAŌオŘŁA͈ԍɖ߂
//***************************
void	check_static(void)
{
	unsigned short	us;
	unsigned char	kazu = 0;
	unsigned char	keta = 0;

	led_on();										// LED ON
	delay_ms(500);									// 500mS Delay
	led_off();										// LED OFF
	delay_ms(500);									// 500mS Delay
	led_on();										// LED ON
	delay_ms(500);									// 500mS Delay
	led_off();										// LED OFF
	delay_ms(500);									// 500mS Delay
	led_on();										// LED ON
	wait_sw_off();									// XCb`@܂ŉiv[v
	led_off();										// LED OFF

	get_sw();

	sei();											// 荞݉
	delay_ms(10);									// 100mS Delay
	get_sw();
	delay_ms(10);									// 100mS Delay
	get_sw();
	delay_ms(10);									// 100mS Delay

	bef1_ad_ave = 0;
	disp_static_colon(1);							// Rnm
	keta = 4;
	kazu = 1;
	led_off();										// LED OFF
	tim_10ms_ad = 0;

	for(;;){
		us = get_action_sw();									// XCb`Ԃ
		us &= SW_MASK;											// XCb`ɂ

		if((us == SW2_OFF_SHORT)||(us == SW2_OFF_LONG)){		// XCb`NbNꂽ(select switch)
			kazu++;
			if(keta == 4){										// R̎
				if(1 < kazu){
					kazu = 0;
				}
				if(kazu == 0){									//  Rnee̎
					disp_static_colon(0);						//   Rnee
				}else{
					disp_static_colon(1);						//   Rnm
				}
			}else{
				if(9 < kazu){
					kazu = 0;
				}
				disp_static_nixie_number(keta, kazu);			// 
			}
		}

		if((us == SW1_OFF_SHORT)||(us == SW1_OFF_LONG)){		// XCb`NbNꂽ(set switch)
			keta++;
			if(4 < keta){										// R̎
				keta = 0;
			}
			if(keta == 4){										// R̎
				if(kazu == 0){									//  Rnee̎
					disp_static_colon(0);						//   Rnee
				}else{
					disp_static_colon(1);						//   Rnm
				}
			}else{
				disp_static_nixie_number(keta, kazu);			// 
			}
		}
	}

}
//***************************
// `FbNi_Ci~bN\js
//  kdcQx_łAŏʂƓԖڂɂW\
//  XCb`ėꂽ eO`XAĕ\iPbԊuŕ\ωj
//    ԉĚ̎̓R\
//***************************
void	check_dynamic(void)
{
	unsigned short	us;
	unsigned char	old_run = 0;
	unsigned char	kazu = 0;
	unsigned char	keta = 0;
	unsigned char	old_keta = 1;
	unsigned char	pause = 0;

	led_on();										// LED ON
	delay_ms(500);									// 500mS Delay
	led_off();										// LED OFF
	delay_ms(500);									// 500mS Delay
	led_on();										// LED ON
	wait_sw_off();									// XCb`@܂ŉiv[v
	led_off();										// LED OFF

	get_sw();

	tim_10ms_blink = 0;								// uNp^C}[𗬗p
	old_run = run;
	sei();											// 荞݉
	delay_ms(10);									// 100mS Delay
	get_sw();
	delay_ms(10);									// 100mS Delay
	get_sw();
	delay_ms(10);									// 100mS Delay

	bef1_ad_ave = 0;
	disp_dynamic_nixie_number(0, VER_DATA/100);		// ŏʌ  o[W\
	disp_dynamic_nixie_number(1, (VER_DATA%100)/10);// QԖڌ  o[W\
	disp_dynamic_nixie_number(2, VER_DATA%10);		// RԖڌ  o[W\
	disp_dynamic_nixie_number(3, 15);				// ŉʌ  
	led_off();										// LED OFF
	tim_10ms_ad = 0;
	dynamic_nixie_active(1);						// _Ci~bN\Jn
	for(;;){
		us = get_action_sw();									// XCb`Ԃ
		us &= SW_MASK;											// XCb`ɂ
		if(us == SW2_OFF_LONG){									// XCb`ėꂽ(select switch)
			edit_eep_data();									// ddoqnlDATAҏWiiv[vj
			break;												// ̃[v𔲂iۂ̓ł͔Ȃj
		}

		if(us == SW2_OFF_SHORT){								// XCb`Zėꂽ(select switch)
			disp_dynamic_nixie_number(0, 15);					// ŏʌ  
			disp_dynamic_nixie_number(1, 15);					// QԖڌ  
			disp_dynamic_nixie_number(2, 15);					// RԖڌ  
			disp_dynamic_nixie_number(3, 15);					// ŉʌ  
			break;												// ̃[v𔲂
		}
	}


	for(;;){
		us = get_action_sw();									// XCb`Ԃ
		us &= SW_MASK;											// XCb`ɂ

		if(us == SW2_OFF_SHORT){								// XCb`Zėꂽ(select switch)
			pause ^= 1;											// ړ\𒆒f or Jn
		}

		if(tim_10ms_blink == 0){
			tim_10ms_blink = 100;								// 1000mS Ԋu
			if(pause == 0){
				disp_dynamic_colon(0);							// R
				if(old_keta != keta){							// ς
					disp_dynamic_nixie_number(old_keta, 15);	// Ǒ̐
					old_keta = keta;
				}
				if(kazu == 10){									// \PO̎
					disp_dynamic_colon(1);						// R
					disp_dynamic_nixie_number(keta, 15);		// 
				}else{
					disp_dynamic_nixie_number(keta, kazu);		// 
				}
				kazu++;
				if(10 < kazu){									// \POȏɂȂ
					kazu = 0;									// Oɖ߂
					keta++;
					if(g_keta == keta){							// ԉE̕\iƗRj̎
						kazu = 10;
					}else if(g_keta < keta){					// \߂
						keta = 0;
					}
				}
			}
		}
	}

}
//***************************
// Aj[V\
//@ODPbɌĂ΂
// 
//@FP̂
// ߂l
//@OAj[Vr
//@PAj[VI
//***************************
unsigned char	disp_animation(unsigned char init)
{
	static	unsigned char	ani_keta = 0;		//  0--4 (0--3 A 4 R)
	static	unsigned char	ani_kazu = 0;		// l 0--9, 10=colon
	unsigned char			r = 0;
	unsigned char			kazu_max = 9;

	if (init == 1){
		ani_keta = 0;
		ani_kazu = 0;
	}else{
		if(ani_kazu == 0){
			for(ani_kazu=0;ani_kazu <= g_keta;ani_kazu++){
				disp_dynamic_nixie_number(ani_kazu, 15);
				disp_dynamic_colon(0);
			}
			ani_kazu = 0;
		}

		if(ani_keta == g_keta){									// ŉEiƗRj
				disp_dynamic_nixie_number(ani_keta, 15);
				disp_dynamic_colon(1);
				kazu_max = 1;
		}else{
			if((ani_keta & 1) == 0){									// 
				disp_dynamic_nixie_number(ani_keta, renzoku[ani_kazu]);
			}else{														// E
				disp_dynamic_nixie_number(ani_keta, gyaku_renzoku[ani_kazu]);
			}
			kazu_max = 9;
		}
		ani_kazu++;
		if(kazu_max < ani_kazu){
			ani_kazu = 0;
			ani_keta++;								// ̌
			if(g_keta < ani_keta){
				ani_keta = 0;
				r = 1;
			}
		}
	}

	return(r);
}

//***************************
//  Sp Main
//***************************
static	void	main_4keta(void)
{
	unsigned short	check_path_valu;
	unsigned short	us;
	unsigned char	disp_clock_mode=HM;
	unsigned char	old_disp_clock_mode=HM;
	unsigned char	old_rtc_1s_flg=0xff;
	unsigned char	old_RTC_min = 0xff;
	unsigned char	old_RTC_hou = 0xff;
	unsigned char	old_RTC_mon = 0xff;
	unsigned char	old_RTC_day = 0xff;
	unsigned char	old_RTC_year = 0xff;
	unsigned char	uc;
	unsigned char	dark = 0;						// 0: 邢  1:Â

	sei();											// 荞݉

	bef1_ad_ave = 0;

	tim_10ms_nixie = 100;
	dynamic_nixie_active(1);						// _Ci~bN\Jn

	while(1){
		us = get_action_sw();									// XCb`Ԃ
		us &= SW_MASK;											// XCb`ɂ
		if(us == SW1_OFF_LONG){									// ꂽ(set switch)
			proc_no_key_timeup(1);								// L[͂L
			disp_clock_mode = SET;
			proc_set_rtc();										// v킹
			disp_clock_mode = HM;
			old_RTC_min = 0xff;
			old_rtc_1s_flg = (rtc_1s_flg - 1);
		}else if(us == SW2_OFF_SHORT){							// Zꂽ(select switch)
			proc_no_key_timeup(1);								// L[͂L
			switch(disp_clock_mode){							// 샂[hύX
			 case HM:
				disp_clock_mode = MD;
				old_RTC_mon = 0xff;
				old_RTC_day = 0xff;
				break;
			 case MD:
				disp_clock_mode = YE;
				old_RTC_year = 0xff;
				break;
			 case YE:
				disp_clock_mode = HM;
				old_RTC_hou = 0xff;
				old_RTC_min = 0xff;
				break;
			 default:
				disp_clock_mode = HM;
				old_RTC_hou = 0xff;
				old_RTC_min = 0xff;
				break;
			}
			old_rtc_1s_flg = (rtc_1s_flg - 1);					// ɕ\
		}else if(us == SW2_OFF_LONG){							// ꂽ(select switch)
			proc_no_key_timeup(1);								// L[͂L
			if(disp_clock_mode != ANIME){
				if(disp_clock_mode == CDS){						// b[h̎
					disp_clock_mode = TEMPER;					// x\[hɕύX
					old_RTC_year = 0xff;
					old_RTC_mon = 0xff;
					old_RTC_day = 0xff;
				}else if((disp_clock_mode == TEMPER)||(disp_clock_mode == HM)){	// [h@͉x[h̎
					disp_clock_mode = CDS;						// x\[hɕύX
					old_RTC_year = 0xff;
					old_RTC_mon = 0xff;
					old_RTC_day = 0xff;
				}
			}
			old_rtc_1s_flg = (rtc_1s_flg - 1);					// ɕ\
		}else{
			if(rtc_1s_flg != old_rtc_1s_flg){					// qsbĂ鎞̂Pboߗp
				ad5_get_data();									// A/D 5 Get A/D data
				old_rtc_1s_flg = rtc_1s_flg;
				rtc_read();										// RTC ǂݏo
				if(disp_clock_mode == HM){						// [h
					disp_dynamic_colon(1);						// R\ _
					tim_10ms_nixie = 50;
					if((old_RTC_hou != gRTC_hou)||(old_RTC_min != gRTC_min)){	//  ω
						disp_nixie_four(gRTC_hou,gRTC_min);		// ƕ S\
						old_RTC_hou = gRTC_hou;
						old_RTC_min = gRTC_min;
						if((gRTC_min == 0)&&(gRTC_sec == 0)){	// ̎
							disp_dynamic_colon(0);				// R\ 
							disp_clock_mode = ANIME;
							disp_animation(1);					// Aj[V
							old_disp_clock_mode = HM;
						}
					}
				}else if((disp_clock_mode == MD)&&((old_RTC_mon != gRTC_mon)||(old_RTC_day != gRTC_day))){	// [h ω
					disp_nixie_four(gRTC_mon,gRTC_day);			// Ɠ S\
					old_RTC_mon = gRTC_mon;
					old_RTC_day = gRTC_day;
					disp_dynamic_colon(1);						// R\ _
				}else if((disp_clock_mode == YE)&&(old_RTC_year != gRTC_year)){	// N[h Nω
					disp_nixie_four(0x20,gRTC_year);			// N S\
					old_RTC_year = gRTC_year;
					disp_dynamic_colon(0);						// R\ 
				}else if(disp_clock_mode == CDS){				// b[h̎
					disp_nixie_4binary(ad5_ave);				// S\iXXXX܂Łj
					disp_dynamic_colon(0);						// R\ 
				}else if(disp_clock_mode == TEMPER){			// x[h̎
					temperature_read();							// xǂݏo
					disp_nixie_4binary(gTemperature);			// S\iXXXX܂Łj
					disp_dynamic_colon(1);						// R\ _
				}else if(disp_clock_mode == Infr_Data){			// ԊOMf[^[h̎
					disp_nixie_4binary(Ginf_data);				// S\iXXXX܂Łj
					disp_dynamic_colon(0);						// R\ 
				}
				num_count=0;

				// \x̒
				check_path_valu = change_path;
				check_path_valu *= 100;
				if(dark == 1){									// Â
					if (check_path_valu < 50){
						check_path_valu = 0;
					}else{
						check_path_valu -= 50;
					}
					if (ad5_ave < check_path_valu){
						path_limit = 1;
						dark = 0;
					}
				}else{
					check_path_valu += 50;
					if (check_path_valu < ad5_ave){
						path_limit = 4;
						dark = 1;
					}
				}
			}

			if (proc_no_key_timeup(0) == 0xff){					// ԃL[͂
				if((disp_clock_mode != HM)&& (disp_clock_mode != ANIME)){	// \ŖŁAAjł
					disp_clock_mode = HM;
					old_RTC_hou = 0xff;
					old_RTC_min = 0xff;
				}
			}

			if(tim_10ms_nixie == 0){							// TOO
				if(disp_clock_mode == ANIME){					// Aj[V̎
					tim_10ms_nixie = 20;						// POOr^C}[d|
					if(disp_animation(0) == 1){					// \
						disp_clock_mode = old_disp_clock_mode;
						old_RTC_hou = 0xff;
						old_RTC_min = 0xff;
						old_RTC_mon = 0xff;
						old_RTC_day = 0xff;
						old_RTC_year = 0xff;
					}
				}else if(disp_clock_mode == HM){				// ̎
					disp_dynamic_colon(0);						// R\ 
				}
			}
		}

		uc = get_infrared_data();								// ԊORfqf[^
		if(uc == IND2_OFF_SHORT){								// Zꂽ(select switch)
			proc_no_key_timeup(1);								// L[͂L
			switch(disp_clock_mode){							// 샂[hύX
			 case HM:
				disp_clock_mode = MD;
				old_RTC_mon = 0xff;
				old_RTC_day = 0xff;
				break;
			 case MD:
				disp_clock_mode = YE;
				old_RTC_year = 0xff;
				break;
			 case YE:
				disp_clock_mode = HM;
				old_RTC_hou = 0xff;
				old_RTC_min = 0xff;
				break;
			 default:
				disp_clock_mode = HM;
				old_RTC_hou = 0xff;
				old_RTC_min = 0xff;
				break;
			}
			old_rtc_1s_flg = (rtc_1s_flg - 1);					// ɕ\
		}else if(uc == IND2_OFF_LONG){							// ꂽ(select switch)
			proc_no_key_timeup(1);								// L[͂L
			if(disp_clock_mode != ANIME){
				if(disp_clock_mode == CDS){						// b[h̎
					disp_clock_mode = TEMPER;					// x\[hɕύX
				}else if((disp_clock_mode == TEMPER)||(disp_clock_mode == HM)){	// [h@͉x[h̎
					disp_clock_mode = CDS;						// b[hɕύX
				}

				old_RTC_year = 0xff;
				old_RTC_mon = 0xff;
				old_RTC_day = 0xff;
			}
			old_rtc_1s_flg = (rtc_1s_flg - 1);					// ɕ\
		}else if(uc == IND1_OFF_LONG){							// ꂽ(set switch)
			proc_no_key_timeup(1);								// L[͂L
			disp_clock_mode = SET;
			proc_set_rtc_infr();								// ԊO̎v킹
			disp_clock_mode = HM;
			old_RTC_min = 0xff;
			old_rtc_1s_flg = (rtc_1s_flg - 1);
		}

		if(tim_10ms_infrared != 0){
			led_on();											// LED ON
		}else{
			led_off();											// LED OFF
		}


	}
}

//***************************
//  Main
//***************************
int	main(void)
{

	PRR |= ( (1 << PRTWI) | (1 << PRSPI) | (1 << PRUSART0) | (1 << PRTIM0) | (1 << PRTIM1) | (1 << PRTIM2) | (1 << PRADC) );	// TWI, SPI, UART0, Timer0, Timer1, Timer2, ADC ~
	delay_ms(200);									// 200mS Delay


	init_nixe();									// Nixe\ 
	sw_init();										// XCb`֌W̏ݒ
	rtc_init();										// qsb̏ݒ
	led_init();										// kdc֌W̏ݒ
	timer2_init();									// Timer2 Initial
	infrared_init();								// ԊORfq Initial

#if	AD_NO == 6
	ad6_init();										// A/D 6 Initial
#else
 #if	AD_NO == 5
	ad5_init();										// A/D 5 Initial
 #else
	ad0_init();										// A/D 0 Initial
 #endif
#endif

	g_keta = 4;										// KETA = 4 Œ
	path_limit = 1;									// \Ԉ 1--4 (1:bright -- 4:dark)
	change_path = read_eep_change_path();			// ddoqnl change_PATH ǂݍ

	led_on();										// LED ON
	delay_ms(500);									// 500mS Delay
	led_off();										// LED OFF

	if((PIND & SW2_ON_BIT) == 0){					// XCb`f[^Ă(select switch)
		check_dynamic();							// `FbNi_Ci~bN\js
	}

	if((PINB & SW1_ON_BIT) == 0){					// XCb`f[^Ă(set switch)
		check_static();								// `FbNiX^eBbN\js
	}

	main_4keta();									// Sp Main

}
