//*****************************************
// AT mega328P-PU(28pin 300mil SDIP) Four IN-18 Clock Program
// CPU Clock:8MHz
//   iq[Yf[^@UWlgɂj
// File Name:set_rtc_4keta.c
//
//  C:\WinAVR-20100110\doc\avr-libc\avr-libc-user-manual.pdf ɊeCN[ht@C̐
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//*****************************************

#include	<avr/interrupt.h>
#include	<avr/io.h>

#include	"four_in18_clock.h"
#include	"timer.h"
#include	"port_bit.h"
#include	"rtc_ds3234.h"
#include	"display.h"
#include	"nixie.h"
#include	"infrared.h"
#include	"set_rtc_4keta.h"


//*****************************************
// N킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static	unsigned char	proc_set_year_4keta(void)
{
	unsigned char	blk_stat=0;
	unsigned char	ye;
	unsigned short	us;
	unsigned char	r=0;

	ye = gRTC_year;
	disp_nixie_tow_h(0x20);							// N ʂQ\
	disp_nixie_tow_m(ye);							// N ʂQ\
	disp_dynamic_colon(1);							// Rnee

	tim_10ms_blink = 0;								// _
	while(1){
		us = get_action_sw();						// XCb`Ԃ
		us &= SW_MASK;								// XCb`ɂ

		if(tim_10ms_blink == 0){					// _Ń^C~O̎
			tim_10ms_blink = 50;
			if((blk_stat==0)&&((us & SW2_ON) == 0)){	// ĂȂ ł̎(select switch)
				blk_stat = 1;
				disp_nixie_tow_m(0xff);				// uN Q\
			}else{
				blk_stat = 0;
				disp_nixie_tow_m(ye);				// N Q\
			}
		}

		if(us != 0){								// ANVL鎞
			proc_no_key_timeup(1);					// L[͂L
			if(((us & SW2_ON_CONTINUE) != 0)||((us & SW2_ON_NOW) != 0)){	// ꂽA͉ꑱ(select switch)
				ye++;
				if(9 < (ye & 0x0f)){				// X𒴂
					ye &= 0xf0;
					ye += 0x10;
				}
				if(0x99 < ye){
					ye = 0;
				}
			}else if(((us & SW1_OFF_LONG) != 0)||((us & SW1_OFF_SHORT) != 0)){	// ZAAꎞ(set switch)
				if(gRTC_year == ye){				// lύXĂȂ
					r = 0;
				}else{
					gRTC_year = ye;
					rtc_write();					// RTC 
				}
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){			// ԃL[͂
			r = 0xff;
			break;
		}
	}

	disp_dynamic_colon(0);							// Rnee

	return(r);
}
//*****************************************
// 킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static	unsigned char	proc_set_month_4keta(void)
{
	unsigned char	blk_stat=0;
	unsigned char	mo;
	unsigned short	us;
	unsigned char	r=0;

	mo = gRTC_mon;
	disp_nixie_tow_h(mo);							//  ʂQ\
	disp_nixie_tow_m(gRTC_day);						//  ʂQ\
	disp_dynamic_colon(1);							// Rnm

	tim_10ms_blink = 0;								// _
	while(1){
		us = get_action_sw();						// XCb`Ԃ
		us &= SW_MASK;								// XCb`ɂ

		if(tim_10ms_blink == 0){					// _Ń^C~O̎
			tim_10ms_blink = 50;
			if((blk_stat==0)&&((us & SW2_ON) == 0)){	// ꂢȂ ł̎(select switch)
				blk_stat = 1;
				disp_nixie_tow_h(0xff);				// uN ʂQ\
			}else{
				blk_stat = 0;
				disp_nixie_tow_h(mo);				//  ʂQ\
			}
		}

		if(us != 0){								// EANVL鎞
			proc_no_key_timeup(1);					// L[͂L
			if(((us & SW2_ON_CONTINUE) != 0)||((us & SW2_ON_NOW) != 0)){	// ꂽA͉ꑱ(select switch)
				mo++;
				if(9 < (mo & 0x0f)){				// X𒴂
					mo &= 0xf0;
					mo += 0x10;
				}
				if(0x12 < mo){
					mo = 1;
				}
			}else if(((us & SW1_OFF_LONG) != 0)||((us & SW1_OFF_SHORT) != 0)){	// ZAAꎞ(set switch)
				if(gRTC_mon == mo){					// lύXĂȂ
					r = 0;
				}else{
					gRTC_mon = mo;
					rtc_write();					// RTC 
				}
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){			// ԃL[͂
			r = 0xff;
			break;
		}
	}

	disp_dynamic_colon(0);							// Rnee

	return(r);
}
//*****************************************
// 킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static	unsigned char	proc_set_day_4keta(void)
{
	unsigned char	blk_stat=0;
	unsigned char	da;
	unsigned short	us;
	unsigned char	r=0;
	unsigned char	uru=0;
	unsigned char	syo=0;

	if(((((gRTC_year/16)*10)+(gRTC_year/16))/4) == 0){	// 邤N
		uru=1;
	}
	if((gRTC_mon == 0x04)||(gRTC_mon == 0x06)||(gRTC_mon == 0x09)||(gRTC_mon == 0x11)){	// ̌
		syo=1;
	}
	da = gRTC_day;
	disp_nixie_tow_h(gRTC_mon);						//  ʂQ\
	disp_nixie_tow_m(da);							//  ʂQ\
	disp_dynamic_colon(1);							// Rnm

	tim_10ms_blink = 0;								// _
	while(1){
		us = get_action_sw();						// XCb`Ԃ
		us &= SW_MASK;								// XCb`ɂ

		if(tim_10ms_blink == 0){					// _Ń^C~O̎
			tim_10ms_blink = 50;
			if((blk_stat==0)&&((us & SW2_ON) == 0)){	// ꂢȂ ł̎(select switch)
				blk_stat = 1;
				disp_nixie_tow_m(0xff);				// uN Q\
			}else{
				blk_stat = 0;
				disp_nixie_tow_m(da);				//  Q\
			}
		}

		if(us != 0){								// ANVL鎞
			proc_no_key_timeup(1);					// L[͂L
			if(((us & SW2_ON_CONTINUE) != 0)||((us & SW2_ON_NOW) != 0)){	// ꂽA͉ꑱ(select switch)
				da++;
				if(9 < (da & 0x0f)){				// X𒴂
					da &= 0xf0;
					da += 0x10;
				}
				if(syo == 1){						// ̌
					if(0x30 < da){
						da = 1;
					}
				}else if(gRTC_mon == 0x02){
					if(uru == 1){					// Q 邤N
						if(0x29 < da){
							da = 1;
						}
					}else{							// Q N
						if(0x28 < da){
							da = 1;
						}
					}
				}else{								// ̌
					if(0x31 < da){
						da = 1;
					}
				}
			}else if(((us & SW1_OFF_LONG) != 0)||((us & SW1_OFF_SHORT) != 0)){	// ZAAꎞ(set switch)
				if(gRTC_day == da){					// lύXĂȂ
					r = 0;
				}else{
					gRTC_day = da;
					rtc_write();					// RTC 
				}
				break;								// I
			}
		}

		if (proc_no_key_timeup(0) == 0xff){			// ԃL[͂
			r = 0xff;
			break;
		}
	}

	disp_dynamic_colon(0);							// Rnee

	return(r);
}
//*****************************************
// 킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static	unsigned char	proc_set_hour_4keta(void)
{
	unsigned char	blk_stat=0;
	unsigned char	ho;
	unsigned short	us;
	unsigned char	r=0;

	ho = gRTC_hou;
	disp_nixie_tow_h(ho);							//  ʂQ\
	disp_nixie_tow_m(gRTC_min);						//  ʂQ\
	disp_dynamic_colon(1);							// Rnm

	tim_10ms_blink = 0;								// _
	while(1){
		us = get_action_sw();						// XCb`Ԃ
		us &= SW_MASK;								// XCb`ɂ

		if(tim_10ms_blink == 0){					// _Ń^C~O̎
			tim_10ms_blink = 50;
			if((blk_stat==0)&&((us & SW2_ON) == 0)){	// ꂢȂ ł̎(select switch)
				blk_stat = 1;
				disp_nixie_tow_h(0xff);				// uN ʂQ\
				disp_dynamic_colon(0);				// Rnee
			}else{
				blk_stat = 0;
				disp_nixie_tow_h(ho);				//  ʂQ\
				disp_dynamic_colon(1);				// Rnm
			}
		}

		if(us != 0){								// ANVL鎞
			proc_no_key_timeup(1);					// L[͂L
			if(((us & SW2_ON_CONTINUE) != 0)||((us & SW2_ON_NOW) != 0)){	// ꂽA͉ꑱ(select switch)
				ho++;
				if(9 < (ho & 0x0f)){				// X𒴂
					ho &= 0xf0;
					ho += 0x10;
				}
				if(0x23 < ho){
					ho = 0;
				}
			}else if(((us & SW1_OFF_LONG) != 0)||((us & SW1_OFF_SHORT) != 0)){	// ZAAꎞ(set switch)
				if(gRTC_hou == ho){					// lύXĂȂ
					r = 0;
				}else{
					gRTC_hou = ho;
					rtc_write();					// RTC 
				}
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){			// ԃL[͂
			r = 0xff;
			break;
		}
	}

	disp_dynamic_colon(0);							// Rnee

	return(r);
}
//*****************************************
// 킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static	unsigned char	proc_set_minute_4keta(void)
{
	unsigned char	blk_stat=0;
	unsigned char	mi;
	unsigned short	us;
	unsigned char	r=0;

	mi = gRTC_min;
	disp_nixie_tow_h(gRTC_hou);						//  ʂQ\
	disp_nixie_tow_m(mi);							//  ʂQ\
	disp_dynamic_colon(1);							// Rnm

	tim_10ms_blink = 0;								// _
	while(1){
		us = get_action_sw();						// XCb`Ԃ
		us &= SW_MASK;								// XCb`ɂ

		if(tim_10ms_blink == 0){					// _Ń^C~O̎
			tim_10ms_blink = 50;
			if((blk_stat==0)&&((us & SW2_ON) == 0)){	// ꂢȂ ł̎(select switch)
				blk_stat = 1;
				disp_nixie_tow_m(0xff);				// uN ʂQ\
				disp_dynamic_colon(0);				// Rnee
			}else{
				blk_stat = 0;
				disp_nixie_tow_m(mi);				//  ʂQ\
				disp_dynamic_colon(1);				// Rnm
			}
		}

		if(us != 0){								// ANVL鎞
			proc_no_key_timeup(1);					// L[͂L
			if(((us & SW2_ON_CONTINUE) != 0)||((us & SW2_ON_NOW) != 0)){	// ꂽA͉ꑱ(select switch)
				mi++;
				if(9 < (mi & 0x0f)){				// X𒴂
					mi &= 0xf0;
					mi += 0x10;
				}
				if(0x59 < mi){
					mi = 0;
				}
			}else if(((us & SW1_OFF_LONG) != 0)||((us & SW1_OFF_SHORT) != 0)){	// ZAAꎞ(set switch)
				if(gRTC_min == mi){					// lύXĂȂ
					r = 0;
				}else{
					gRTC_min = mi;
					gRTC_sec = 0;
					rtc_write();					// RTC 
				}
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){			// ԃL[͂
			r = 0xff;
			break;
		}
	}

	disp_dynamic_colon(0);					// Rnee

	return(r);
}
//*****************************************
// Sv킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
// @̊֐ł QOOũtB[hobN͊|ĂȂ
// @@ԂẐł̂܂܂ŗǂƂ
//*****************************************
unsigned char	proc_set_rtc_4keta(void)
{
	unsigned char	r;

	r = proc_set_year_4keta();						// N킹
	if(r == 0){
		r = proc_set_month_4keta();					// 킹
		if(r == 0){
			r = proc_set_day_4keta();				// 킹
			if(r == 0){
				r = proc_set_hour_4keta();			// 킹
				if(r == 0){
					r = proc_set_minute_4keta();	// 킹
				}
			}
		}
	}
	return(r);
}

//*****************************************
// ԊO̔N킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static	unsigned char	proc_set_year_infr_4keta(void)
{
	unsigned char	blk_stat=0;
	unsigned char	ye;
	unsigned char	uc;
	unsigned char	r=0;
	unsigned char	key_on=0;

	ye = gRTC_year;
	disp_nixie_tow_h(0x20);							// N ʂQ\
	disp_nixie_tow_m(ye);							// N ʂQ\
	disp_dynamic_colon(1);							// Rnee

	tim_10ms_blink = 0;								// _
	while(1){
		uc = get_infrared_data();					// ԊORfqf[^

		if(tim_10ms_blink == 0){					// _Ń^C~O̎
			tim_10ms_blink = 50;
			if((blk_stat==0)&&(key_on == 0)){		// ł̎  ԊO@\L[nee̎
				blk_stat = 1;
				disp_nixie_tow_m(0xff);				// uN Q\
			}else{
				blk_stat = 0;
				disp_nixie_tow_m(ye);				// N Q\
			}
		}

		if(uc != 0){								// ANVL鎞
			proc_no_key_timeup(1);					// L[͂L
			if((uc == IND1_ON_NOW) || (uc == IND2_ON_NOW)){	// ꂽA(select & set switch)
				key_on = 1;							// L[ꂽ
			}
			if((uc == IND1_OFF_SHORT) || (uc == IND1_OFF_LONG) || (uc == IND2_OFF_SHORT) || (uc == IND2_OFF_LONG)){	// ZĂĂ@ꂽA(select & set switch)
				key_on = 0;							// L[ꂽ
			}
			if((uc == IND2_ON_CONTINUE)||(uc == IND2_ON_NOW)){	// ꂽA͉ꑱ(select switch)
				ye++;
				if(9 < (ye & 0x0f)){				// X𒴂
					ye &= 0xf0;
					ye += 0x10;
				}
				if(0x99 < ye){
					ye = 0;
				}
			}else if((uc == IND1_OFF_LONG)||(uc == IND1_OFF_SHORT)){	// ZAAꎞ(set switch)
				if(gRTC_year == ye){				// lύXĂȂ
					r = 0;
				}else{
					gRTC_year = ye;
					rtc_write();					// RTC 
				}
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){			// ԃL[͂
			r = 0xff;
			break;
		}

		if(tim_10ms_infrared != 0){
			led_on();								// LED ON
		}else{
			led_off();								// LED OFF
		}

	}

	disp_dynamic_colon(0);							// Rnee

	return(r);
}
//*****************************************
// ԊǑ킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static	unsigned char	proc_set_month_infr_4keta(void)
{
	unsigned char	blk_stat=0;
	unsigned char	mo;
	unsigned char	uc;
	unsigned char	r=0;
	unsigned char	key_on=0;

	mo = gRTC_mon;
	disp_nixie_tow_h(mo);							//  ʂQ\
	disp_nixie_tow_m(gRTC_day);						//  ʂQ\
	disp_dynamic_colon(1);							// Rnm

	tim_10ms_blink = 0;								// _
	while(1){
		uc = get_infrared_data();					// ԊORfqf[^

		if(tim_10ms_blink == 0){					// _Ń^C~O̎
			tim_10ms_blink = 50;
			if((blk_stat==0)&&(key_on == 0)){		// ł̎  ԊO@\L[nee̎
				blk_stat = 1;
				disp_nixie_tow_h(0xff);				// uN ʂQ\
			}else{
				blk_stat = 0;
				disp_nixie_tow_h(mo);				//  ʂQ\
			}
		}

		if(uc != 0){								// EANVL鎞
			proc_no_key_timeup(1);					// L[͂L
			if((uc == IND1_ON_NOW) || (uc == IND2_ON_NOW)){	// ꂽA(select & set switch)
				key_on = 1;							// L[ꂽ
			}
			if((uc == IND1_OFF_SHORT) || (uc == IND1_OFF_LONG) || (uc == IND2_OFF_SHORT) || (uc == IND2_OFF_LONG)){	// ZĂĂ@ꂽA(select & set switch)
				key_on = 0;							// L[ꂽ
			}
			if((uc == IND2_ON_CONTINUE)||(uc == IND2_ON_NOW)){	// ꂽA͉ꑱ(select switch)
				mo++;
				if(9 < (mo & 0x0f)){				// X𒴂
					mo &= 0xf0;
					mo += 0x10;
				}
				if(0x12 < mo){
					mo = 1;
				}
			}else if((uc == IND1_OFF_LONG)||(uc == IND1_OFF_SHORT)){	// ZAAꎞ(set switch)
				if(gRTC_mon == mo){					// lύXĂȂ
					r = 0;
				}else{
					gRTC_mon = mo;
					rtc_write();					// RTC 
				}
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){			// ԃL[͂
			r = 0xff;
			break;
		}

		if(tim_10ms_infrared != 0){
			led_on();								// LED ON
		}else{
			led_off();								// LED OFF
		}

	}

	disp_dynamic_colon(0);							// Rnee

	return(r);
}
//*****************************************
// ԊO̓킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static	unsigned char	proc_set_day_infr_4keta(void)
{
	unsigned char	blk_stat=0;
	unsigned char	da;
	unsigned char	uc;
	unsigned char	r=0;
	unsigned char	uru=0;
	unsigned char	syo=0;
	unsigned char	key_on=0;

	if(((((gRTC_year/16)*10)+(gRTC_year/16))/4) == 0){	// 邤N
		uru=1;
	}
	if((gRTC_mon == 0x04)||(gRTC_mon == 0x06)||(gRTC_mon == 0x09)||(gRTC_mon == 0x11)){	// ̌
		syo=1;
	}
	da = gRTC_day;
	disp_nixie_tow_h(gRTC_mon);						//  ʂQ\
	disp_nixie_tow_m(da);							//  ʂQ\
	disp_dynamic_colon(1);							// Rnm

	tim_10ms_blink = 0;								// _
	while(1){
		uc = get_infrared_data();					// ԊORfqf[^

		if(tim_10ms_blink == 0){					// _Ń^C~O̎
			tim_10ms_blink = 50;
			if((blk_stat==0)&&(key_on == 0)){		// ł̎  ԊO@\L[nee̎
				blk_stat = 1;
				disp_nixie_tow_m(0xff);				// uN Q\
			}else{
				blk_stat = 0;
				disp_nixie_tow_m(da);				//  Q\
			}
		}

		if(uc != 0){								// ANVL鎞
			proc_no_key_timeup(1);					// L[͂L
			if((uc == IND1_ON_NOW) || (uc == IND2_ON_NOW)){	// ꂽA(select & set switch)
				key_on = 1;							// L[ꂽ
			}
			if((uc == IND1_OFF_SHORT) || (uc == IND1_OFF_LONG) || (uc == IND2_OFF_SHORT) || (uc == IND2_OFF_LONG)){	// ZĂĂ@ꂽA(select & set switch)
				key_on = 0;							// L[ꂽ
			}
			if((uc == IND2_ON_CONTINUE)||(uc == IND2_ON_NOW)){	// ꂽA͉ꑱ(select switch)
				da++;
				if(9 < (da & 0x0f)){				// X𒴂
					da &= 0xf0;
					da += 0x10;
				}
				if(syo == 1){						// ̌
					if(0x30 < da){
						da = 1;
					}
				}else if(gRTC_mon == 0x02){
					if(uru == 1){					// Q 邤N
						if(0x29 < da){
							da = 1;
						}
					}else{							// Q N
						if(0x28 < da){
							da = 1;
						}
					}
				}else{								// ̌
					if(0x31 < da){
						da = 1;
					}
				}
			}else if((uc == IND1_OFF_LONG)||(uc == IND1_OFF_SHORT)){	// ZAAꎞ(set switch)
				if(gRTC_day == da){					// lύXĂȂ
					r = 0;
				}else{
					gRTC_day = da;
					rtc_write();					// RTC 
				}
				break;								// I
			}
		}

		if (proc_no_key_timeup(0) == 0xff){			// ԃL[͂
			r = 0xff;
			break;
		}

		if(tim_10ms_infrared != 0){
			led_on();								// LED ON
		}else{
			led_off();								// LED OFF
		}

	}

	disp_dynamic_colon(0);							// Rnee

	return(r);
}
//*****************************************
// ԊO̎킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static	unsigned char	proc_set_hour_infr_4keta(void)
{
	unsigned char	blk_stat=0;
	unsigned char	ho;
	unsigned char	uc;
	unsigned char	r=0;
	unsigned char	key_on=0;

	ho = gRTC_hou;
	disp_nixie_tow_h(ho);							//  ʂQ\
	disp_nixie_tow_m(gRTC_min);						//  ʂQ\
	disp_dynamic_colon(1);							// Rnm

	tim_10ms_blink = 0;								// _
	while(1){
		uc = get_infrared_data();					// ԊORfqf[^

		if(tim_10ms_blink == 0){					// _Ń^C~O̎
			tim_10ms_blink = 50;
			if((blk_stat==0)&&(key_on == 0)){		// ł̎  ԊO@\L[nee̎
				blk_stat = 1;
				disp_nixie_tow_h(0xff);				// uN ʂQ\
				disp_dynamic_colon(0);				// Rnee
			}else{
				blk_stat = 0;
				disp_nixie_tow_h(ho);				//  ʂQ\
				disp_dynamic_colon(1);				// Rnm
			}
		}

		if(uc != 0){								// ANVL鎞
			proc_no_key_timeup(1);					// L[͂L
			if((uc == IND1_ON_NOW) || (uc == IND2_ON_NOW)){	// ꂽA(select & set switch)
				key_on = 1;							// L[ꂽ
			}
			if((uc == IND1_OFF_SHORT) || (uc == IND1_OFF_LONG) || (uc == IND2_OFF_SHORT) || (uc == IND2_OFF_LONG)){	// ZĂĂ@ꂽA(select & set switch)
				key_on = 0;							// L[ꂽ
			}
			if((uc == IND2_ON_CONTINUE)||(uc == IND2_ON_NOW)){	// ꂽA͉ꑱ(select switch)
				ho++;
				if(9 < (ho & 0x0f)){				// X𒴂
					ho &= 0xf0;
					ho += 0x10;
				}
				if(0x23 < ho){
					ho = 0;
				}
			}else if((uc == IND1_OFF_LONG)||(uc == IND1_OFF_SHORT)){	// ZAAꎞ(set switch)
				if(gRTC_hou == ho){					// lύXĂȂ
					r = 0;
				}else{
					gRTC_hou = ho;
					rtc_write();					// RTC 
				}
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){			// ԃL[͂
			r = 0xff;
			break;
		}

		if(tim_10ms_infrared != 0){
			led_on();								// LED ON
		}else{
			led_off();								// LED OFF
		}

	}

	disp_dynamic_colon(0);							// Rnee

	return(r);
}
//*****************************************
// ԊO̕킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static	unsigned char	proc_set_minute_infr_4keta(void)
{
	unsigned char	blk_stat=0;
	unsigned char	mi;
	unsigned char	uc;
	unsigned char	r=0;
	unsigned char	key_on=0;

	mi = gRTC_min;
	disp_nixie_tow_h(gRTC_hou);						//  ʂQ\
	disp_nixie_tow_m(mi);							//  ʂQ\
	disp_dynamic_colon(1);							// Rnm

	tim_10ms_blink = 0;								// _
	while(1){
		uc = get_infrared_data();					// ԊORfqf[^

		if(tim_10ms_blink == 0){					// _Ń^C~O̎
			tim_10ms_blink = 50;
			if((blk_stat==0)&&(key_on == 0)){		// ł̎  ԊO@\L[nee̎
				blk_stat = 1;
				disp_nixie_tow_m(0xff);				// uN ʂQ\
				disp_dynamic_colon(0);				// Rnee
			}else{
				blk_stat = 0;
				disp_nixie_tow_m(mi);				//  ʂQ\
				disp_dynamic_colon(1);				// Rnm
			}
		}

		if(uc != 0){								// ANVL鎞
			proc_no_key_timeup(1);					// L[͂L

			if((uc == IND1_ON_NOW) || (uc == IND2_ON_NOW)){	// ꂽA(select & set switch)
				key_on = 1;							// L[ꂽ
			}
			if((uc == IND1_OFF_SHORT) || (uc == IND1_OFF_LONG) || (uc == IND2_OFF_SHORT) || (uc == IND2_OFF_LONG)){	// ZĂĂ@ꂽA(select & set switch)
				key_on = 0;							// L[ꂽ
			}
			if((uc == IND2_ON_CONTINUE)||(uc == IND2_ON_NOW)){	// ꂽA͉ꑱ(select switch)
				mi++;
				if(9 < (mi & 0x0f)){				// X𒴂
					mi &= 0xf0;
					mi += 0x10;
				}
				if(0x59 < mi){
					mi = 0;
				}
			}else if((uc == IND1_OFF_LONG)||(uc == IND1_OFF_SHORT)){	// ZAAꎞ(set switch)
				if(gRTC_min == mi){					// lύXĂȂ
					r = 0;
				}else{
					gRTC_min = mi;
					gRTC_sec = 0;
					rtc_write();					// RTC 
				}
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){			// ԃL[͂
			r = 0xff;
			break;
		}

		if(tim_10ms_infrared != 0){
			led_on();								// LED ON
		}else{
			led_off();								// LED OFF
		}

	}

	disp_dynamic_colon(0);					// Rnee

	return(r);
}
//*****************************************
// ԊÔSv킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
// @̊֐ł QOOũtB[hobN͊|ĂȂ
// @@ԂẐł̂܂܂ŗǂƂ
//*****************************************
unsigned char	proc_set_rtc_infr_4keta(void)
{
	unsigned char	r;

	r = proc_set_year_infr_4keta();						// ԊO̔N킹
	if(r == 0){
		r = proc_set_month_infr_4keta();				// ԊǑ킹
		if(r == 0){
			r = proc_set_day_infr_4keta();				// ԊO̓킹
			if(r == 0){
				r = proc_set_hour_infr_4keta();			// ԊO̎킹
				if(r == 0){
					r = proc_set_minute_infr_4keta();	// ԊO̕킹
				}
			}
		}
	}
	return(r);
}

